"use strict";
/**
 * @file TreeItem 扩展，增加了对父子的引用和 change 事件
 * @author weijiaxun <weijiaxun@baidu.com>
 */
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
const vscode = __importStar(require("vscode"));
class ExtendedTreeItem {
    constructor(value) {
        this.value = value;
        this.children = [];
        this.parent = null;
        this._onDidChange = new vscode.EventEmitter();
        this.onDidChange = this._onDidChange.event;
    }
    appendChild(element) {
        element.parent = this;
        this.children.push(element);
        this._onDidChange.fire(this);
    }
    removeChild(element) {
        this.children = this.children.filter(item => item !== element);
        this._onDidChange.fire(this);
    }
    insertBefore(element, beforeElement) {
        const index = this.children.findIndex(item => item === beforeElement);
        const existingIndex = this.children.findIndex(item => item === element);
        if (existingIndex > -1) {
            // reorder the element instead of inserting a new one
            this.children.splice(existingIndex, 1);
        }
        this.children.splice(index + 1, 0, element);
        this._onDidChange.fire(this);
    }
    update(props) {
        props.forEach((payload) => {
            this.value[payload.type] = payload.value;
        });
        this._onDidChange.fire(this);
    }
}
exports.default = ExtendedTreeItem;
//# sourceMappingURL=ExtendedTreeItem.js.map