"use strict";
/**
 * @file TreeItem 组件，这一层主要的目的是为了把一些 props 计算的逻辑拿出来
 * @author weijiaxun<weijiaxun@baidu.com>
 */
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const vscode = __importStar(require("vscode"));
const react_1 = __importStar(require("react"));
const VSCTreeItem_1 = __importDefault(require("./VSCTreeItem"));
const TreeItem = ({ label = '', id, iconPath, description, resourceUri, tooltip, command: rawCommand, contextValue, expanded, children, context, }) => {
    const collapsibleState = (0, react_1.useMemo)(() => {
        if (children == null) {
            return vscode.TreeItemCollapsibleState.None;
        }
        if (expanded === true) {
            return vscode.TreeItemCollapsibleState.Expanded;
        }
        return vscode.TreeItemCollapsibleState.Collapsed;
    }, [children, expanded]);
    const command = (0, react_1.useMemo)(() => {
        if (!rawCommand) {
            return undefined;
        }
        return typeof rawCommand === 'string'
            ? { command: rawCommand, title: '' }
            : rawCommand;
    }, [rawCommand]);
    const vscTreeItemProps = {
        label,
        id,
        iconPath,
        description,
        resourceUri,
        tooltip,
        command,
        collapsibleState,
        contextValue,
        context,
    };
    return react_1.default.createElement(VSCTreeItem_1.default, Object.assign({}, vscTreeItemProps), children);
};
exports.default = TreeItem;
//# sourceMappingURL=TreeItem.js.map