/**
 * @file 暴露给 React Reconciler 的组件，和 vscode TreeItem 直接对应
 * @author weijiaxun <weijiaxun@baidu.com>
 */
import React from 'react';
import * as vscode from 'vscode';
declare const VSCTreeItem: React.FC<VSCTreeItemProps>;
export default VSCTreeItem;
export interface VSCTreeItemProps {
    label?: string;
    id?: string;
    iconPath?: string | vscode.Uri | {
        light: string | vscode.Uri;
        dark: string | vscode.Uri;
    } | vscode.ThemeIcon;
    description?: string | boolean;
    resourceUri?: vscode.Uri;
    tooltip?: string | undefined;
    command?: vscode.Command;
    collapsibleState?: vscode.TreeItemCollapsibleState;
    contextValue?: string;
    context?: any;
}
export type Props = React.PropsWithChildren<VSCTreeItemProps>;
export declare const propKeys: (keyof Props)[];
export interface UpdatePayload<T extends keyof Props = keyof Props> {
    type: T;
    value: Props[T];
}
//# sourceMappingURL=VSCTreeItem.d.ts.map