"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const vscode = __importStar(require("vscode"));
const react_reconciler_1 = __importDefault(require("react-reconciler"));
const constants_js_1 = require("react-reconciler/constants.js");
const VSCTreeItem_1 = require("./VSCTreeItem");
exports.default = (0, react_reconciler_1.default)({
    supportsMutation: true,
    createInstance(_type, props, container) {
        const { label = '', id, iconPath, description, resourceUri, tooltip, command, collapsibleState, contextValue, context } = props;
        const treeItem = new vscode.TreeItem(label, collapsibleState);
        treeItem.id = id;
        treeItem.iconPath = iconPath;
        treeItem.description = description;
        treeItem.resourceUri = resourceUri;
        treeItem.tooltip = tooltip;
        treeItem.command = command;
        treeItem.contextValue = contextValue;
        treeItem.context = context;
        return container.createTreeItem(treeItem);
    },
    appendChildToContainer(container, child) {
        container.appendChildToRoot(child);
    },
    appendChild(parentInstance, child) {
        parentInstance.appendChild(child);
    },
    appendInitialChild(parentInstance, child) {
        parentInstance.appendChild(child);
    },
    removeChildFromContainer(container, child) {
        container.removeChildFromRoot(child);
    },
    removeChild(parentInstance, child) {
        parentInstance.removeChild(child);
    },
    insertInContainerBefore(container, child, beforeChild) {
        container.insertInRootBefore(child, beforeChild);
    },
    insertBefore(parentInstance, child, beforeChild) {
        parentInstance.insertBefore(child, beforeChild);
    },
    prepareUpdate(_instance, _type, oldProps, newProps) {
        const res = [];
        for (const key of VSCTreeItem_1.propKeys) {
            if (oldProps[key] !== newProps[key]) {
                res.push({
                    type: key,
                    value: newProps[key]
                });
            }
        }
        return res;
    },
    commitUpdate(instance, updatePayload) {
        instance.update(updatePayload);
    },
    detachDeletedInstance() { },
    prepareForCommit() {
        return null;
    },
    clearContainer() { },
    // @ts-ignore
    finalizeInitialChildren() { },
    getChildHostContext() { },
    getPublicInstance(instance) {
        return instance;
    },
    getRootHostContext() { },
    resetAfterCommit() { },
    shouldSetTextContent() {
        return false;
    },
    scheduleTimeout: function (fn, delay) {
        return setTimeout(fn, delay);
    },
    cancelTimeout: function (id) {
        clearTimeout(id);
    },
    noTimeout: -1,
    getCurrentEventPriority: function () {
        return constants_js_1.DefaultEventPriority;
    },
});
//# sourceMappingURL=reconciler.js.map